var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { r as registerInstance, h } from './index-eb36fb29.js';
import './index-938f79c5.js';
import { g as getPackageWithoutVersion, p as packageToElementName } from './utils-af16fd11.js';
import { b as browser, d as docson, j as jsonBeautify, c as classnames, m as merge_1, t as throttle_1, i as index } from './browser-f69671c8.js';
import { a as cloneDeep_1 } from './identity-47313e7a.js';
import { r as range_1 } from './_setToString-59e11976.js';
import './_baseIsEqual-193273ca.js';
import { i as isEqual_1 } from './isEqual-a2938832.js';
var pieDemoCss = "@import url(\"https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css\");@import url(\"https://fonts.googleapis.com/css?family=Roboto\");@import url(\"https://fonts.googleapis.com/icon?family=Material+Icons\");.docson{font-family:'Droid Sans',verdana,helvetica;font-size:13px;padding:6px 6px 6px 6px}.docson .box{position:relative;float:left;width:100%;background-color:rgba(255, 255, 255, 0.2);border:1px solid lightgrey;border-radius:4px;-moz-border-radius:4px;-webkit-border-radius:4px;padding-bottom:10px;-moz-box-shadow:1px 1px 1px darkgray;-webkit-box-shadow:1px 1px 1px darkgray;box-shadow:1px 1px 1px darkgray}.docson .expand-button{position:absolute;margin-top:15px;padding:2px;right:2px;float:right;width:18px;text-align:center;cursor:pointer;font-weight:bold;font-family:\"Lucida Console\", Monaco, monospace;font-size:15px;color:darkgray;display:none}.docson .source-button{position:absolute;padding:2px;margin-top:3px;right:2px;width:18px;text-align:center;cursor:pointer;font-weight:bold;font-family:\"Lucida Console\", Monaco, monospace;font-size:10px;color:darkgray;display:none}.docson .box-header{padding:6px;border-top-left-radius:4px;border-top-right-radius:4px;border-bottom:1px solid lightgrey;background:whitesmoke;}.docson .box-name{color:darkblue;padding:5px 40px 2px 3px;float:left;width:100%}.docson .title{margin-top:-3px;font-size:120%}.docson .link{text-decoration:underline}.docson .box-description{color:dimgray;float:left;width:100%}.docson .end{clear:both}.docson .error{color:red}.docson .box-body{padding-left:10px;padding-right:28px;clear:both}.docson .box-1{background:whitesmoke;}.docson .box-2{background:beige;background:-webkit-linear-gradient(white, beige, beige, gainsboro);background:-moz-linear-gradient(white, beige, beige, gainsboro)}.docson .box-3{background:azure;background:-webkit-linear-gradient(white, azure, azure, gainsboro);background:-moz-linear-gradient(white, azure, azure, gainsboro)}.docson .box-4{background:mistyrose;background:-webkit-linear-gradient(white, mistyrose, mistyrose, gainsboro);background:-moz-linear-gradient(white, mistyrose, mistyrose, gainsboro)}.docson .box-5{background:#ddffee;background:-webkit-linear-gradient(white, #ddffee, #ddffee, gainsboro);background:-moz-linear-gradient(white, #ddffee, #ddffee, gainsboro)}.docson .box-6{background:ghostwhite;background:-webkit-linear-gradient(white, ghostwhite, ghostwhite, gainsboro);background:-moz-linear-gradient(white, ghostwhite, ghostwhite, gainsboro)}.docson .box-7{background:lavenderblush;background:-webkit-linear-gradient(white, lavenderblush, lavenderblush, gainsboro);background:-moz-linear-gradient(white, lavenderblush, lavenderblush, gainsboro)}.docson .box-8{background:aliceblue;background:-webkit-linear-gradient(white, aliceblue, aliceblue, gainsboro);background:-moz-linear-gradient(white, aliceblue, aliceblue, gainsboro)}.docson .signature{padding-top:5px;clear:left}.docson .signature-header{padding-top:3px;height:20px;line-height:24px}.docson .property-name{float:left;width:100%;font-family:\"Lucida Console\", Monaco, monospace;min-width:130px}.docson .required{font-weight:bold}.docson .type-keyword{font-size:80%;color:dimgray}.docson .type-pattern{font-size:80%;color:darkolivegreen}.docson .type-enum{color:purple;font-family:\"Lucida Console\", Monaco, monospace;font-size:90%;padding-left:2px}.docson .type-default{color:darkslategrey;font-family:\"Lucida Console\", Monaco, monospace}.docson .signature-type{padding-left:6px;float:left;width:100%;min-width:160px}.docson .signature-type-any{font-style:italic}.docson .signature-type-string{color:green}.docson .signature-type-number{color:blue}.docson .signature-type-integer{color:blueviolet}.docson .signature-type-boolean{color:orangered}.docson .signature-type-null{font-family:\"Lucida Console\", Monaco, monospace;color:red}.docson .signature-type-date-time{color:#224466}.docson .signature-type-email{color:cornflowerblue}.docson .signature-type-hostname{color:darkolivegreen}.docson .signature-type-ipv6{color:darkslateblue}.docson .signature-type-ipv4{color:indigo}.docson .signature-type-uri{color:saddlebrown}.docson .signature-button{cursor:pointer;padding:4px;border-radius:4px;border:1px solid lightgrey;-moz-border-radius:4px}.docson .signature-type-ref{color:darkblue}.docson .signature-type-expanded{padding:5px 3px 3px 5px;vertical-align:-1px;opacity:0.6;-moz-box-shadow:inset 1px 1px 1px darkgray;-webkit-box-shadow:inset 1px 1px 1px darkgray;box-shadow:inset 1px 1px 1px darkgray}.docson .signature-description{padding-left:6px;padding-bottom:3px;color:dimgray;float:left;width:100%}.docson .signature-box-container{clear:both}.docson .box-container{float:left;width:100%;padding-top:4px;padding-left:8px;display:none}.docson .button{-webkit-touch-callout:none;-webkit-user-select:none;-khtml-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.docson .button:hover{color:darkred}@media all and (min-width: 20px) and (max-width: 500px){.docson .property-name{min-width:0px}.docson .signature-type{min-width:0px}.docson .source{width:100%}.docson .box-container,.box{width:100%}}.docson .desc{padding-left:6px;line-height:17px}.docson .desc p{margin:0;margin-top:3px}.docson .desc code{color:purple;font-size:90%}.docson .desc table{margin-top:4px;margin-bottom:4px;border-collapse:collapse}.docson .desc th{padding:0px;font-size:80%;font-weight:normal;background:rgba(231, 231, 231, 0.5)}.docson .desc table,.docson .desc th,.docson .desc td{border:1px solid lightgrey}.docson .desc tr>td{padding:2px 6px 2px 6px}.docson .desc h1{font-size:120%;margin-top:0px;margin-bottom:3px}.docson .desc h2{font-size:115%;margin-top:0px;margin-bottom:3px}.docson .desc h3{font-size:110%;margin-top:0px;margin-bottom:3px}.docson .desc h4{font-size:100%;margin-top:0px;margin-bottom:3px}.docson .desc pre{border:1px solid lightgray;border-radius:4px;-webkit-border-radius:4px;-moz-border-radius:4px;padding:4px;margin:3px 0px}.docson .desc ul{padding-left:16px;margin:3px 0px}.docson .desc ol{padding-left:16px;margin:3px 0px}.docson .desc blockquote{margin:3px 0px 3px 10px;padding-left:6px;border-left:1px solid lightgray}.docson .desc img{vertical-align:middle}.docson .desc hr{border:0;height:1px;background:lightgrey;color:lightgrey;width:50%}.docson .source{display:none;padding-left:16px;padding-right:30px}.docson .json,.json-schema{font-family:\"Lucida Console\", Monaco, monospace}.docson .json-punctuation{font-weight:bold}.docson .json-null,.json-true,.json-false{font-weight:bold}.docson .json-true{color:#080}.docson .json-false{color:#800}.docson .json-object-key{color:#246}.docson .json-keyword{font-weight:bold;color:#036}.docson .json-number{font-weight:bold;color:#660}.docson .json-string{color:#800}.docson .json-schema-map>.json-object-key{color:#080;font-style:italic}html,body{height:100%;margin:0;padding:0}.doc-holder{background-color:rgba(0, 0, 0, 0.2);-ms-flex-align:end;align-items:flex-end;bottom:0;display:none;-ms-flex-direction:column;flex-direction:column;position:fixed;right:0;top:0;width:100%;z-index:101}.doc-holder .close-icon{margin:0;position:absolute;right:20px;top:20px;z-index:1}.doc-holder #schema-holder{padding:0;height:100%;width:70%}.doc-holder #schema-holder .box{background:#fff;height:100%}.doc-holder #schema-holder .box .box-body{height:calc(100% - 85px);overflow:scroll}.doc-holder #schema-holder>.box>.box-header{background-color:#3f51b5;height:65px}.doc-holder #schema-holder>.box>.box-header .box-title .box-description p{color:#ffffff;font-size:20px;font-weight:500;line-height:65px}.doc-holder.mobile #schema-holder{width:100%}.doc-holder.visible{display:-ms-flexbox;display:flex}mjx-container.MathJax *:not(mjx-math){font-family:inherit}*:not(i){font-family:Roboto, serif}.root{background-color:#3f51b5;display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;max-height:100%;height:100%;position:relative}.root.multiplePies{height:50%}.root.loading{background:transparent}.control-bar{color:grey;display:-ms-flexbox;display:flex;font-size:16px;font-weight:bold;min-height:76px;-ms-flex-pack:justify;justify-content:space-between;width:100%}.control-bar.justElement{display:none}.control-bar .collapse-icon{border-radius:4px;border:1px solid #3f51b5;color:#3f51b5;font-size:16px;margin-right:18px;padding:7px}.control-bar .collapse-icon.collapsed{background-color:#3f51b5;color:#fff}.control-bar .toggle-icon{cursor:pointer;margin-right:20px}.control-bar .toggle-icon.toggled{color:#f9a825}.control-bar .authoring-header{background:#fff;-ms-flex-align:center;align-items:center;display:-ms-flexbox;display:flex;-ms-flex:1;flex:1;height:76px;-ms-flex-pack:center;justify-content:center;position:relative}.control-bar .authoring-header .topContent .toggle-text{font-size:12px;margin-right:10px}.control-bar .authoring-header .bottomContent{background:#fff;bottom:0;display:none;height:calc(100vh - 76px);left:0;position:absolute;top:76px;width:100%;z-index:100}.control-bar .authoring-header .bottomContent .tabs-container{height:100%}.control-bar .authoring-header .bottomContent .tabs-container .tab-content{height:calc(100% - 52px)}.control-bar .authoring-header .bottomContent .json-config{-ms-flex-align:start;align-items:flex-start;-webkit-box-sizing:border-box;box-sizing:border-box;display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;height:100%;padding:16px;width:100%}.control-bar .authoring-header .bottomContent .json-config .json-config-header{-ms-flex-align:center;align-items:center;-webkit-box-sizing:border-box;box-sizing:border-box;display:-ms-flexbox;display:flex;-ms-flex-pack:justify;justify-content:space-between;padding:16px 0;width:100%}.control-bar .authoring-header .bottomContent .json-config .json-config-header .right-content{-ms-flex-align:center;align-items:center;display:-ms-flexbox;display:flex;-ms-flex-pack:justify;justify-content:space-between}.control-bar .authoring-header .bottomContent .json-config .json-config-header .view-container,.control-bar .authoring-header .bottomContent .json-config .json-config-header .right-content>div{cursor:pointer}.control-bar .authoring-header .bottomContent .json-config .json-config-header .right-content .copy-container{margin-right:25px}.control-bar .authoring-header .bottomContent .json-config .json-config-header i{margin-right:8px}.control-bar .authoring-header .bottomContent .json-config textarea{resize:none}.control-bar .authoring-header .bottomContent .json-config .json-content{background-color:#ffffff;border:1px solid #ddd;-webkit-box-shadow:0 8px 10px 0 rgba(0, 0, 0, 0.07), 0 2px 4px 0 rgba(0, 0, 0, 0.05);box-shadow:0 8px 10px 0 rgba(0, 0, 0, 0.07), 0 2px 4px 0 rgba(0, 0, 0, 0.05);-webkit-box-sizing:border-box;box-sizing:border-box;color:#000000;font-size:12px;height:100%;padding:16px;width:100%}.close-icon{background-color:#ffffff;border:1px solid #3f51b5;border-radius:4px;color:#3f51b5;cursor:pointer;font-size:12px;height:32px;line-height:32px;margin-right:18px;text-align:center;width:32px}.control-bar .header-title{display:-ms-flexbox;display:flex;-ms-flex:1;flex:1;-ms-flex-direction:column;flex-direction:column;margin-left:24px}.control-bar .header-title .title-info{display:-ms-flexbox;display:flex;-ms-flex-pack:start;justify-content:flex-start}.control-bar .header-title .title-info .option{margin-right:5px;text-transform:uppercase}.control-bar .header-title .title-info i{font-size:4px;margin-right:5px;vertical-align:middle}.control-bar .header-title span{font-size:12px;font-weight:300;line-height:1.5;color:rgba(0, 0, 0, 0.56)}.control-bar .header-title .title-info h4{color:rgba(0, 0, 0, 0.87);font-size:16px;font-weight:500;margin:0 8px 4px 0;text-align:left}.control-bar .student-view-header.collapsed,.control-bar .authoring-header.collapsed{max-width:56px}.control-bar .authoring-header.collapsed .header-title,.control-bar .student-view-header.collapsed .header-title{display:none}.control-bar .authoring-header.collapsed i,.control-bar .student-view-header.collapsed i{margin:0}.control-bar .authoring-header.collapsed .buttons-container,.control-bar .student-view-header.collapsed .buttons-container{display:none}.control-bar .student-view-header{background:#fff;-ms-flex:1 0 0px;flex:1 0 0;height:76px}.control-bar .student-view-header .bottomContent{display:none}.control-bar .bottomContent .tabs-container{display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;position:relative}.control-bar .bottomContent .tabs-container .tabs{background-color:#fafafa;border-bottom:4px solid #eeeeee;display:-ms-flexbox;display:flex;-ms-flex-direction:row;flex-direction:row;height:48px;-ms-flex-pack:start;justify-content:flex-start}.control-bar .bottomContent .tabs-container .tabs .tab{cursor:pointer;color:#000;min-width:100px;height:48px;line-height:48px;text-align:center;width:135px}.control-bar .bottomContent .tabs-container .selected-line{background-color:#3f51b5;bottom:4px;height:4px;position:absolute;top:48px;-webkit-transition:all 300ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;transition:all 300ms cubic-bezier(0.4, 0, 0.2, 1) 0ms}.control-bar .bottomContent .tabs-container .tab-content{height:78px}.control-bar .student-view-header.toggled{height:210px}.control-bar .toggled .bottomContent{display:block;height:134px}.control-bar .toggled .topContent{height:76px}.control-bar .topContent{-ms-flex-align:center;align-items:center;display:-ms-flexbox;display:flex;-ms-flex-pack:center;justify-content:center;height:100%;width:100%}.control-bar .topContent .mobile-button{width:auto}.control-bar .topContent .toggle-text{font-size:12px;margin-right:10px}.control-bar .topContent .buttons-container{-ms-flex-align:center;align-items:center;-webkit-box-sizing:border-box;box-sizing:border-box;display:-ms-flexbox;display:flex;-ms-flex-pack:justify;justify-content:space-between;padding:0 16px}.control-bar .topContent .buttons-container .toggle-container{-ms-flex-align:center;align-items:center;background-color:#ffffff;border:1px solid #3f51b5;border-radius:4px;-webkit-box-sizing:border-box;box-sizing:border-box;cursor:pointer;display:-ms-flexbox;display:flex;height:32px;-ms-flex-pack:justify;justify-content:space-between;margin-right:5px;padding:8px;width:105px}.control-bar .topContent .buttons-container .toggle-container.student{width:82px}.control-bar .topContent .buttons-container .toggle-container i{color:#3f51b5;font-size:16px;margin-right:0}.control-bar .topContent .buttons-container .toggle-container .toggle-text{color:#3f51b5;margin-right:0 !important}.control-bar .topContent .buttons-container .toggle-container.toggled{background-color:#3f51b5}.control-bar .topContent .buttons-container .toggle-container.toggled i{color:#fff}.control-bar .topContent .buttons-container .toggle-container.toggled .toggle-text{color:#fff}.control-bar .topContent h4{margin-bottom:10px}.control-bar .student-view-header .bottomContent{height:126px}.control-bar .bottomContent .settings-tab-container{background-color:#fff;-ms-flex-align:start;align-items:flex-start;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;height:100%;-ms-flex-pack:start;justify-content:flex-start;padding-left:20px;width:100%}.control-bar .bottomContent .settings-tab-container .roles-settings,.control-bar .bottomContent .settings-tab-container .modes-settings{-ms-flex-item-align:center;align-self:center}.control-bar .bottomContent .settings-tab-container .roles-settings h5,.control-bar .bottomContent .settings-tab-container .modes-settings h5{font-size:12px;margin:0 0 8px 0}.control-bar .bottomContent .settings-tab-container .roles-settings .roles-options,.control-bar .bottomContent .settings-tab-container .modes-settings .modes-options{-ms-flex-align:center;align-items:center;display:-ms-flexbox;display:flex;-ms-flex-pack:center;justify-content:center}.control-bar .bottomContent .settings-tab-container .roles-settings .roles-options>*,.control-bar .bottomContent .settings-tab-container .modes-settings .modes-options>*{margin-right:18px}.control-bar.mobile{-ms-flex-align:center;align-items:center;background:#fff;display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;min-height:76px;width:100%}.control-bar.mobile .buttons{-ms-flex-align:center;align-items:center;-webkit-box-sizing:border-box;box-sizing:border-box;display:-ms-flexbox;display:flex;height:76px;-ms-flex-pack:justify;justify-content:space-between;padding:0 16px;width:100%}.mobile-button{-ms-flex-align:center;align-items:center;background-color:#ffffff;border:1px solid #3f51b5;border-radius:4px;-webkit-box-sizing:border-box;box-sizing:border-box;cursor:pointer;display:-ms-flexbox;display:flex;height:32px;-ms-flex-pack:justify;justify-content:space-between;margin-right:5px;padding:8px;width:105px}.mobile-button span{color:#3f51b5;font-size:14px !important;line-height:1.39;letter-spacing:normal;margin:0 !important}.control-bar.mobile .student-tab-content{width:100%}.control-bar.mobile .student-tab-content .toggle-settings{-ms-flex-align:center;align-items:center;-webkit-box-sizing:border-box;box-sizing:border-box;display:-ms-flexbox;display:flex;-ms-flex-pack:start;justify-content:flex-start;margin-bottom:20px;padding:0 20px;width:400px}.control-bar.mobile .student-tab-content .toggle-settings span{font-size:12px;margin-right:10px}.control-bar.mobile .student-tab-content .bottomContent{display:none}.control-bar.mobile.toggled .student-tab-content .bottomContent{display:block;height:134px}.control-bar.mobile.toggled .student-tab-content .bottomContent.smaller{display:block;height:204px}.control-bar.mobile.toggled .student-tab-content .bottomContent.smaller .settings-tab-container{-webkit-box-sizing:border-box;box-sizing:border-box;-ms-flex-direction:column;flex-direction:column;padding:20px}.control-bar.mobile.toggled .student-tab-content .bottomContent.smaller .settings-tab-container .roles-settings{-ms-flex-item-align:start;align-self:flex-start}.control-bar.mobile.toggled .student-tab-content .bottomContent.smaller .settings-tab-container .modes-settings{-ms-flex-item-align:start;align-self:flex-start;margin-bottom:20px}.control-bar.mobile.toggled .student-tab-content .bottomContent.smaller .tabs-container .tab-content{height:152px}.smaller-view{height:100%;width:100%}.smaller-view .authoring-holder{height:calc(100% - 76px)}.smaller-view .student-view-holder{height:calc(100% - 120px)}.smaller-view .student-view-holder.toggled{height:calc(100% - 254px)}.smaller-view .element-holder{border:16px solid #3f51b5;-ms-flex:1;flex:1;height:calc(100% - 32px);overflow:scroll;width:98%}.smaller-view .element-parent{background:#fff;border-radius:4px;overflow:scroll;padding:20px}.smaller-view .element-holder{width:98%}.smaller-view.mobile .authoring-header:not(.toggled){height:100px}.smaller-view.mobile .topContent .buttons-container{width:100%}.smaller-view.mobile .authoring-header:not(.toggled) .topContent{-ms-flex-align:start;align-items:flex-start;-ms-flex-direction:column;flex-direction:column}.smaller-view.mobile .authoring-header:not(.toggled) .topContent .header-title{margin-left:16px;max-height:36px !important}.smaller-view.mobile .authoring-header:not(.toggled) .topContent .header-title span{display:none}.smaller-view.mobile .authoring-header.toggled .topContent .header-title{width:100%}.smaller-view.mobile .authoring-header.toggled .topContent .header-title span{font-size:10px}.config-holder{background-color:#3f51b5;display:-ms-flexbox;display:flex;-ms-flex:1;flex:1;height:100%;width:100%}.config-holder .element-holder{position:absolute;top:76px;left:0;width:96%;overflow:auto;border:16px solid #3f51b5;-ms-flex:1;flex:1;height:calc(100% - 108px)}.config-holder .element-holder.justElement{top:0}.config-holder .element-holder.toggled{top:210px}.config-holder .element-parent{background:#fff;border-radius:4px;overflow:auto;padding:20px;position:relative}.config-holder .collapsed-panel{-ms-flex-pack:center;justify-content:center;background:#fff;display:-ms-flexbox;display:flex;color:#707070;max-width:56px;-ms-flex:1;flex:1}.config-holder .collapsed-panel span{line-height:1.83;-webkit-text-orientation:upright;text-orientation:upright;text-transform:uppercase;-webkit-writing-mode:tb-rl;-ms-writing-mode:tb-rl;writing-mode:tb-rl}.config-holder .authoring-holder{display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;-ms-flex:1 0 0px;flex:1 0 0;position:relative}.config-holder .authoring-holder.collapsed{max-width:56px}.toggle-button{background-color:lightgrey;border:none;cursor:pointer;outline:none}.divider{background:#2336a0;-ms-flex:1;flex:1;max-width:2px !important;z-index:9}.divider:after{background-color:#ebebeb;content:\"\";display:block;height:76px;width:2px}.divider.larger:after{height:210px}.config-holder .student-view-holder{display:-ms-flexbox;display:flex;-ms-flex:1 0 0px;flex:1 0 0;-ms-flex-direction:column;flex-direction:column;position:relative}.config-holder .student-view-holder.collapsed{max-width:56px}.score-holder{background:#fff;border-radius:4px;-webkit-box-sizing:border-box;box-sizing:border-box;display:none;margin-bottom:40px;min-height:40px;overflow:scroll;padding:20px;width:100%}.score-holder.visible{display:block}.score-holder .score{margin-bottom:10px}.score-holder pre{border:solid 1px rgba(0, 0, 0, 0.14);background-color:white;padding:8px}.custom-checkbox{display:-ms-inline-flexbox;display:inline-flex;-ms-flex-align:center;align-items:center}.custom-checkbox i{color:#3f51b5;margin-right:8px}[class*=\"MuiCheckbox-checked\"]{color:green !important}.root .lmask{position:absolute;height:100%;width:100%;background-color:#fff;bottom:0;left:0;right:0;top:0;z-index:9999;opacity:0.4}.root .lmask.fixed{position:fixed}.root .lmask:before{content:\"\";background-color:rgba(0, 0, 0, 0);border:5px solid rgba(63, 81, 181, 0.9);opacity:0.9;border-right:5px solid rgba(0, 0, 0, 0);border-left:5px solid rgba(0, 0, 0, 0);border-radius:50px;-webkit-box-shadow:0 0 35px rgba(63, 81, 181, 0.9);box-shadow:0 0 35px rgba(63, 81, 181, 0.9);width:50px;height:50px;-moz-animation:spinPulse 1s infinite ease-in-out;-webkit-animation:spinPulse 1s infinite linear;margin:-25px 0 0 -25px;position:absolute;top:50%;left:50%}.root .lmask:after{content:\"\";background-color:rgba(0, 0, 0, 0);border:5px solid rgba(63, 81, 181, 0.9);opacity:0.9;border-left:5px solid rgba(0, 0, 0, 0);border-right:5px solid rgba(0, 0, 0, 0);border-radius:50px;-webkit-box-shadow:0 0 15px rgba(63, 81, 181, 0.9);box-shadow:0 0 15px rgba(63, 81, 181, 0.9);width:30px;height:30px;-moz-animation:spinoffPulse 1s infinite linear;-webkit-animation:spinoffPulse 1s infinite linear;margin:-15px 0 0 -15px;position:absolute;top:50%;left:50%}@-webkit-keyframes spinPulse{0%{-webkit-transform:rotate(160deg);transform:rotate(160deg);opacity:0;-webkit-box-shadow:0 0 1px rgba(63, 81, 181, 0.9);box-shadow:0 0 1px rgba(63, 81, 181, 0.9)}50%{-webkit-transform:rotate(145deg);transform:rotate(145deg);opacity:1}100%{-webkit-transform:rotate(-320deg);transform:rotate(-320deg);opacity:0}}@keyframes spinPulse{0%{-webkit-transform:rotate(160deg);transform:rotate(160deg);opacity:0;-webkit-box-shadow:0 0 1px rgba(63, 81, 181, 0.9);box-shadow:0 0 1px rgba(63, 81, 181, 0.9)}50%{-webkit-transform:rotate(145deg);transform:rotate(145deg);opacity:1}100%{-webkit-transform:rotate(-320deg);transform:rotate(-320deg);opacity:0}}@-webkit-keyframes spinoffPulse{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes spinoffPulse{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}";
var log = browser('pie-framework:pie-demo');
var ViewState;
(function (ViewState) {
    ViewState[ViewState["LOADING"] = 0] = "LOADING";
    ViewState[ViewState["READY"] = 1] = "READY";
    ViewState[ViewState["ERROR"] = 2] = "ERROR";
})(ViewState || (ViewState = {}));
var defaultController = {
    model: function (model, session, env) {
        log(model, session, env);
        return Object.assign(Object.assign({}, model), { mode: env.mode });
    },
    outcome: function () { return ({
        score: 0,
        details: {}
    }); }
};
var PieDemoContent = /** @class */ (function () {
    function class_1(hostRef) {
        var _this = this;
        registerInstance(this, hostRef);
        /**
         * Removes control bar if true
         * @type {boolean}
         */
        this.justElement = false;
        /**
         * Makes the element have 50% height
         * @type {boolean}
         */
        this.multiplePies = false;
        /**
         * Link to the pie-schema markdown file
         * @type {boolean}
         */
        this.modelSchemaJSONURI = null;
        /**
         * Link to the pie-schema markdown file
         * @type {boolean}
         */
        this.configureSchemaJSONURI = null;
        /**
         * Tells the component if it needs to load the elements or not
         */
        this.load = true;
        /**
         * Include an editor in the view
         */
        this.editor = true;
        /**
         * Include an item preview in the view
         */
        this.preview = true;
        /**
         * Include control panel for adjusting player settings.
         */
        this.playerControls = true;
        this.state = ViewState.LOADING;
        // each key will be a package name, without version
        this.pieControllers = {};
        this.minHeightAuthoring = 'initial';
        this.minHeightStudent = 'initial';
        this.rootElWidth = 1250;
        this.bottomContElWidth = 550;
        this.tabIndex = 0;
        this.mobileTabIndex = 0;
        this.currentOption = 'student';
        this.studSettVisible = false;
        this.authSettVisible = false;
        this.docHolderVisible = false;
        this.env = { mode: 'gather' };
        this.sessions = {};
        this.scores = {};
        this._renderStudent = false;
        this.imageHandler = null;
        this.configureSchemaJSON = null;
        this.modelSchemaJSON = null;
        // todo replace cached Json config
        this.cachedJsonConfig1 = null;
        this.rootEl = null;
        this.fileInput = null;
        this._renderingAuthor = false;
        this._renderingStudent = false;
        this.getProperController = function (model) {
            var divA = document.createElement('div');
            if ('markup' in _this.config) {
                divA.innerHTML = _this.config.markup;
                if (model.id) {
                    var tag = Object.keys(_this.config.elements).find(function (key) { return key === divA.querySelector("[id=\"" + model.id + "\"]").tagName.toLowerCase(); });
                    var packageWithoutVersion = getPackageWithoutVersion(_this.config.elements[tag]);
                    var controller = _this.pieControllers[packageWithoutVersion];
                    return {
                        controller: controller,
                        tag: tag
                    };
                }
                return {};
            }
            return {};
        };
        this.viewDocumentation = function (tabIndex) {
            log('Tab Index', tabIndex);
            var currentContent = tabIndex === 1 ? _this.modelSchemaJSON : _this.configureSchemaJSON;
            _this.docHolderVisible = true;
            docson.doc('schema-holder', currentContent);
        };
        this.renderJsonConfigPanel = function (jsonData, index) {
            log(jsonData);
            return (h("div", { class: "json-config" }, h("div", { class: "json-config-header" }, h("div", { class: "view-container", onClick: function () { return _this.viewDocumentation(index); } }, h("i", { class: "fa fa-desktop" }), h("span", null, "View Documentation")), h("div", { class: "right-content" }, h("div", { class: "copy-container", onClick: function () {
                    _this["textAreaContentRef" + index].select();
                    document.execCommand('copy');
                } }, h("i", { class: "fa fa-clone" }), h("span", null, "Copy JSON")), h("div", { class: "reset-container", onClick: function () {
                    if (_this["textAreaContentRef" + index]) {
                        if (index === 1) {
                            _this["textAreaContentRef" + index].value = jsonBeautify(_this["cachedJsonConfig" + index], null, 2, 98);
                            _this.config = _this["cachedJsonConfig" + index];
                        }
                        else {
                            _this["textAreaContentRef" + index].value = jsonBeautify(_this.configSettings, null, 2, 98);
                            _this.configureObject = _this.configSettings;
                        }
                    }
                } }, h("i", { class: "fa fa-undo" }), h("span", null, "Reset")))), h("textarea", { ref: function (el) { return (_this["textAreaContentRef" + index] = el); }, class: "json-content", value: jsonBeautify(jsonData, null, 2, 98), onChange: function (e) {
                    var target = e.target;
                    if (index === 1) {
                        _this.config = JSON.parse(target.value);
                    }
                    else {
                        _this.configureObject = JSON.parse(target.value);
                    }
                } })));
        };
        this.renderTabs = function (tabs, tabWidth) {
            if (tabWidth === void 0) { tabWidth = 100; }
            var content = tabs[_this.tabIndex] ? tabs[_this.tabIndex].content : null;
            var contentValue = typeof content === 'function' ? content() : content;
            return (h("div", { class: "tabs-container" }, h("div", { class: "tabs" }, tabs.map(function (tab, index) { return (h("div", { style: {
                    width: tabWidth + "px"
                }, class: classnames('tab', {
                    selected: _this.tabIndex === index
                }), onClick: function () { return (_this.tabIndex = index); } }, tab.name)); })), h("span", { class: "selected-line", style: {
                    left: _this.tabIndex * tabWidth + "px",
                    width: tabWidth + "px"
                } }), h("div", { class: "tab-content" }, contentValue)));
        };
        this.renderAuthoringHolder = function (smallView) {
            if (smallView === void 0) { smallView = false; }
            var isCollapsed = _this.collapsed === 'authoring';
            _this._renderingAuthor = true;
            return (h("div", { class: classnames('authoring-holder', {
                    collapsed: _this.collapsed === 'authoring',
                    toggled: _this.isToggled()
                }) }, h("div", { class: classnames('control-bar', {
                    justElement: _this.justElement
                }) }, _this.renderAuthoringHeader(smallView)), isCollapsed &&
                _this.renderCollapsedPanel('Authoring View', _this.isToggled()), !isCollapsed && (h("div", { ref: function (el) { return el && (_this.elementParent1 = el); }, class: classnames('element-holder', {
                    justElement: _this.justElement
                }) }, h("div", { class: "element-parent", style: {
                    minHeight: _this.minHeightAuthoring + "px"
                } }, h("pie-author", { class: "pie-author", ref: function (el) { return el && (_this.pieAuthor = el); }, config: _this.config, configSettings: _this.configureObject, canWatchConfigSettings: true, reFetchBundle: true }, ' ')))), h("input", { type: "file", hidden: true, ref: function (r) { return (_this.fileInput = r); } })));
        };
        this.renderStudentHolder = function (smallView) {
            if (smallView === void 0) { smallView = false; }
            var isCollapsed = _this.collapsed === 'student';
            _this._renderingStudent = true;
            if (!_this._renderStudent) {
                return null;
            }
            return (h("div", { class: classnames('student-view-holder', {
                    collapsed: _this.collapsed === 'student',
                    toggled: _this.isToggled()
                }) }, h("div", { class: classnames('control-bar', {
                    justElement: _this.justElement
                }) }, _this.renderStudentHeader(smallView)), isCollapsed && _this.renderCollapsedPanel('Student View'), !isCollapsed && (h("div", { class: classnames('element-holder', {
                    toggled: _this.studSettVisible,
                    justElement: _this.justElement
                }) }, h("div", { class: classnames('score-holder', { visible: _this.env['mode'] === 'evaluate' }) }, h("span", null, "Scores:"), Object.keys(_this.scores).map(function (scoreKey, index) { return (h("div", { class: "score" }, h("span", null, "Item ", index + 1, ": "), " ", _this.scores[scoreKey].score, _this.scores[scoreKey].json && h("pre", null, _this.scores[scoreKey].json))); })), h("div", { ref: function (el) { return el && (_this.elementParent2 = el); }, class: "element-parent", style: {
                    minHeight: _this.minHeightStudent + "px"
                } }, h("pie-player", { class: "pie-player", ref: function (el) { return el && (_this.piePlayer = el); }, config: _this.config, reFetchBundle: true }, ' '))))));
        };
        this.renderContent = function () {
            if (_this.rootElWidth >= 1200) {
                return (h("div", { class: "config-holder" }, _this.renderAuthoringHolder(), h("span", { class: classnames('divider', {
                        larger: _this.studSettVisible && _this.authSettVisible
                    }) }), _this.renderStudentHolder()));
            }
            return (h("div", { class: classnames('smaller-view', {
                    mobile: _this.rootElWidth <= 700
                }) }, _this.mobileTabIndex === 0 && _this.renderAuthoringHolder(true), _this.mobileTabIndex === 1 && _this.renderStudentHolder(true)));
        };
        this.renderDocHolder = function () {
            return (h("div", { class: classnames('doc-holder', {
                    visible: _this.docHolderVisible,
                    mobile: _this.rootElWidth <= 700
                }) }, h("span", { class: "close-icon", onClick: function () { return (_this.docHolderVisible = false); } }, "X"), h("div", { id: "schema-holder" })));
        };
        this.handleFileInputChange = function (e) {
            var input = e.target;
            if (!_this.imageHandler) {
                console.error('no image handler - but file input change triggered?');
                return;
            }
            log('[handleInputFiles] input.files: ', input);
            var files = input.files;
            if (files.length < 1 || !files[0]) {
                log('[handleInputFiles] = !!! no files.');
                _this.imageHandler.cancel();
                _this.imageHandler = null;
            }
            else {
                var file = files[0];
                _this.imageHandler.fileChosen(file);
                _this.fileInput.value = '';
                var reader_1 = new FileReader();
                reader_1.onload = function () {
                    log('[reader.onload]');
                    var dataURL = reader_1.result;
                    setTimeout(function () {
                        _this.imageHandler.done(null, dataURL.toString());
                        _this.imageHandler = null;
                    }, 2000);
                };
                log('call readAsDataUrl...', file);
                var progress = 0;
                _this.imageHandler.progress(progress, 0, 100);
                range_1(1, 100).forEach(function (n) {
                    setTimeout(function () {
                        _this.imageHandler.progress(n, n, 100);
                    }, n * 20);
                });
                reader_1.readAsDataURL(file);
            }
        };
        this.handleRootEl = this.handleRootEl.bind(this);
        this.handleInsertImage = function (e) {
            log('[handleInsertImage] fileInput:', _this.fileInput);
            _this.imageHandler = e.detail;
            _this.fileInput.click();
        };
        this.handleDeleteImage = function (e) {
            e.detail.done();
        };
    }
    class_1.prototype.componentDidUpdate = function () {
        var _this = this;
        if (this.config && 'elements' in this.config && this.config.elements) {
            var elements_1 = this.config.elements;
            Object.keys(elements_1).map(function (element) {
                try {
                    var authorElName = element + "-config";
                    var authorElement = document.querySelector(authorElName);
                    var configKey = getPackageWithoutVersion(elements_1[element]);
                    if (authorElement) {
                        // @ts-ignore
                        _this.configureObject[configKey] = authorElement._configuration;
                    }
                }
                catch (e) {
                    console.log(e.toString());
                }
            });
        }
        if (this.fileInput) {
            this.fileInput.addEventListener('change', this.handleFileInputChange);
        }
        var isAuthoringToggled = this.isToggled('authoring');
        if (isAuthoringToggled) {
            var offset = 0;
            if (this.bottomContentRef) {
                var ref = this.bottomContentRef.querySelector('.tabs');
                if (ref) {
                    var clientRect = ref.getBoundingClientRect();
                    offset = clientRect.y;
                    this.bottomContentRef.style.height = "calc(100vh - " + offset + "px)";
                }
            }
        }
    };
    class_1.prototype.collapsePanel = function (name) {
        this.collapsed = this.collapsed === name ? null : name;
    };
    class_1.prototype.toggleAuthoringSettings = function () {
        this.authSettVisible = !this.authSettVisible;
    };
    class_1.prototype.validateItem = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // Just call the validation method from pie-author, it will do everything that needs to be done
                    // @ts-ignore
                    return [4 /*yield*/, this.pieAuthor.validateModels()];
                    case 1:
                        // Just call the validation method from pie-author, it will do everything that needs to be done
                        // @ts-ignore
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.toggleStudentSettings = function () {
        this.studSettVisible = !this.studSettVisible;
    };
    class_1.prototype.isToggled = function (type) {
        if (type === void 0) { type = 'student'; }
        if (type === 'student') {
            return this.studSettVisible && this.collapsed !== 'student';
        }
        return this.authSettVisible && this.collapsed !== 'authoring';
    };
    class_1.prototype.detachListeners = function () {
        if (this.rootEl) {
            this.rootResizeObserver.unobserve(this.rootEl);
        }
    };
    class_1.prototype.watchConfig = function (newConfig) {
        var _this = this;
        Object.values(newConfig.elements || {}).map(function (packageNAME) {
            var packageCopy = packageNAME;
            customElements.whenDefined("pp-" + packageToElementName(packageNAME)).then(function () { return __awaiter(_this, void 0, void 0, function () {
                var packageWithoutVersion;
                return __generator(this, function (_a) {
                    packageWithoutVersion = getPackageWithoutVersion(packageCopy);
                    // todo for some reason, the previous components are no longer on window.pie.default, not sure why
                    if (window['pie'].default[packageWithoutVersion].controller || defaultController) {
                        this.pieControllers[packageWithoutVersion] = window['pie'].default[packageWithoutVersion].controller || defaultController;
                    }
                    // if (this.model) {
                    //     this.updatePieModelUsingController(this.model, this.session, this.env);
                    // }
                    this.state = ViewState.READY;
                    return [2 /*return*/];
                });
            }); });
            if (_this.load) {
                _this.state = ViewState.READY;
            }
        });
    };
    class_1.prototype.updatePieModelUsingController = function (model, env, shouldResetSession) {
        return __awaiter(this, void 0, void 0, function () {
            var properController, modelIndex, session, newConfig, scoring, newModel, config;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!('elements' in this.config && 'markup' in this.config)) return [3 /*break*/, 4];
                        properController = this.getProperController(model).controller;
                        modelIndex = this.config.models.findIndex(function (m) { return m.id === model.id; });
                        session = this.sessions[model.id];
                        if (!(properController && properController.model)) return [3 /*break*/, 4];
                        return [4 /*yield*/, properController.model(model, session, env)];
                    case 1:
                        newConfig = _a.sent();
                        if (!(this.env['mode'] === 'evaluate')) return [3 /*break*/, 3];
                        return [4 /*yield*/, properController.outcome(this.config.models.find(function (m) { return m.id === model.id; }), session, this.env)];
                    case 2:
                        scoring = _a.sent();
                        this.scores[model.id] = {
                            score: scoring.score,
                            json: jsonBeautify(scoring.details, null, 2, 80)
                        };
                        _a.label = 3;
                    case 3:
                        if (this.piePlayer) {
                            newModel = merge_1(cloneDeep_1(this.config.models.find(function (m) { return m.id === model.id; })));
                            config = cloneDeep_1(this.config);
                            config.models[modelIndex] = newModel;
                            if (shouldResetSession && this.piePlayer.session) {
                                // only reset that model's session
                                this.piePlayer.session.data[this.piePlayer.session.data.findIndex(function (s) { return s.id === model.id; })] = {};
                            }
                            this.piePlayer.config = config;
                        }
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.handleRootEl = function (current) {
        if (current) {
            this.rootEl = current;
            this.rootResizeObserver.observe(current, {
                attributes: true,
                childList: true,
                subtree: true
            });
        }
        else if (this.rootEl) {
            this.rootResizeObserver.unobserve(this.rootEl);
        }
    };
    class_1.prototype.componentWillLoad = function () {
        var _this = this;
        log('component will load ... ');
        this.watchConfig(this.config);
        var rootHandler = throttle_1(function () {
            if (_this.rootEl) {
                _this.rootElWidth = _this.rootEl.offsetWidth;
            }
        }, 1000, { leading: true });
        this.rootResizeObserver = new index(rootHandler);
        if (this.configSettings) {
            this.configureObject = cloneDeep_1(this.configSettings);
        }
        if (this.modelSchemaJSONURI) {
            this.watchModelSchemaJSONURI(this.modelSchemaJSONURI);
        }
        if (this.configureSchemaJSONURI) {
            this.watchConfigureSchemaJSONURI(this.configureSchemaJSONURI);
        }
        window.global = window;
        docson.templateBaseUrl = '/assets/html';
    };
    /**
     * Pick up @pie-framework/pie-configure-events and trigger an update.
     * TODO: Why cant i use ModelUpdatedEvent.TYPE in the decorator?
     */
    class_1.prototype.onModelUpdated = function (event) {
        if (this._renderingAuthor || this._renderingStudent) {
            this._renderingAuthor = false;
            this._renderingStudent = false;
            return;
        }
        if (!isEqual_1(this.pieAuthor.config, this.config)) {
            this.config = this.pieAuthor.config;
        }
        log('MODEL UPDATED: target:', event.target, event.detail);
        this.updatePieModelUsingController(event.detail.update, this.env, true);
    };
    class_1.prototype.onModelLoaded = function () {
        if (!this._renderStudent) {
            this._renderStudent = true;
        }
    };
    class_1.prototype.onSessionChanged = function (event) {
        log('MODEL UPDATED: target:', event.target, event.detail);
        if (event.target) {
            this.sessions[event.target.session.id] = event.target.session;
        }
    };
    class_1.prototype.watchModelSchemaJSONURI = function (newUrl) {
        var _this = this;
        if (newUrl) {
            fetch(newUrl, {
                mode: 'cors'
            })
                .then(function (response) { return response.json(); })
                .then(function (response) {
                _this.modelSchemaJSON = response;
            });
        }
    };
    class_1.prototype.watchConfigureSchemaJSONURI = function (newUrl) {
        var _this = this;
        if (newUrl) {
            fetch(newUrl, {
                mode: 'cors'
            })
                .then(function (response) { return response.json(); })
                .then(function (response) {
                _this.configureSchemaJSON = response;
            });
        }
    };
    class_1.prototype.setMode = function (mode) {
        var _this = this;
        this.env = Object.assign(Object.assign({}, this.env), { mode: mode });
        if (this.piePlayer) {
            this.piePlayer.env = { mode: mode, role: this.currentOption };
        }
        if ('models' in this.config) {
            this.config.models.forEach(function (model) {
                _this.updatePieModelUsingController(model, _this.env);
            });
        }
    };
    class_1.prototype.setOption = function (option) {
        this.currentOption = option;
        if (this.piePlayer) {
            this.piePlayer.env = { mode: this.env['mode'], role: this.currentOption };
        }
    };
    class_1.prototype.customCheckBox = function (_a) {
        var _this = this;
        var label = _a.label, checked = _a.checked, value = _a.value, _b = _a.action, action = _b === void 0 ? undefined : _b;
        return (h("label", { class: "custom-checkbox", onClick: function () { return action.call(_this, value); } }, h("i", { class: "material-icons" }, checked ? 'radio_button_checked' : 'radio_button_unchecked'), h("span", null, label)));
    };
    class_1.prototype.renderHeaderTitleInfo = function (_a) {
        var title = _a.title, description = _a.description, _b = _a.options, options = _b === void 0 ? undefined : _b;
        return (h("div", { class: "header-title" }, h("div", { class: "title-info" }, h("h4", null, title), options &&
            options.map(function (opt) { return (h("span", { class: "option" }, h("i", { class: "fa fa-circle" }), opt)); })), h("span", null, description)));
    };
    class_1.prototype.renderAuthoringBottomContent = function () {
        var _this = this;
        return this.renderTabs([
            {
                name: 'Item Config',
                content: function () {
                    _this.cachedJsonConfig1 = cloneDeep_1(_this.config);
                    return _this.renderJsonConfigPanel(_this.cachedJsonConfig1, 1);
                }
            },
            {
                name: 'Authoring View Settings',
                content: function () {
                    return _this.renderJsonConfigPanel(_this.configureObject, 2);
                }
            }
        ], 200);
    };
    class_1.prototype.renderAuthoringHeader = function (smallView) {
        var _this = this;
        if (smallView === void 0) { smallView = false; }
        var isToggled = this.isToggled('authoring');
        return (h("div", { class: classnames('authoring-header', {
                collapsed: this.collapsed === 'authoring',
                toggled: isToggled
            }) }, h("div", { class: "topContent" }, this.renderHeaderTitleInfo({
            title: isToggled ? 'Dev Options' : 'Authoring View',
            description: isToggled
                ? 'Lorem ipsum dolor sit amet, consectetur adipisicing elit.'
                : 'The view an author sees when configuring this interaction.'
        }), !isToggled && (h("div", { class: "buttons-container" }, h("div", { class: "toggle-container", onClick: function () { return _this.validateItem(); } }, h("span", { class: "toggle-text" }, "Validate")), h("div", { class: classnames('toggle-container', {
                toggled: this.isToggled('authoring')
            }), onClick: function () { return _this.toggleAuthoringSettings(); } }, h("i", { class: "material-icons toggle-icon" }, this.authSettVisible ? 'toggle_on' : 'toggle_off'), h("span", { class: "toggle-text" }, "Dev Options")), smallView && (h("div", { class: "mobile-button", onClick: function () { return (_this.mobileTabIndex = 1); } }, h("span", null, "STUDENT VIEW"))))), !isToggled && !smallView && (h("i", { class: classnames('material-icons', 'collapse-icon', {
                collapsed: this.collapsed === 'student'
            }), onClick: function () { return _this.collapsePanel('student'); } }, this.collapsed === 'student'
            ? 'format_indent_decrease'
            : 'format_indent_increase')), isToggled && (h("span", { class: "close-icon", onClick: function () { return _this.toggleAuthoringSettings(); } }, "X"))), h("div", { ref: function (el) { return (_this.bottomContentRef = el); }, style: {
                height: '100vh'
            }, class: "bottomContent authoring" }, isToggled && this.renderAuthoringBottomContent())));
    };
    class_1.prototype.renderRoleConfigContainer = function () {
        return (h("div", { class: "roles-settings" }, h("h5", null, "Role"), h("div", { class: "roles-options" }, this.customCheckBox({
            label: 'Student',
            checked: this.currentOption === 'student',
            value: 'student',
            action: this.setOption
        }), this.customCheckBox({
            label: 'Instructor',
            checked: this.currentOption === 'instructor',
            value: 'instructor',
            action: this.setOption
        }))));
    };
    class_1.prototype.renderModeConfigContainer = function () {
        return (h("div", { class: "modes-settings" }, h("h5", null, "Mode"), h("div", { class: "modes-options" }, this.customCheckBox({
            label: 'Gather',
            checked: this.env['mode'] === 'gather',
            value: 'gather',
            action: this.setMode
        }), this.customCheckBox({
            label: 'View',
            checked: this.env['mode'] === 'view',
            value: 'view',
            action: this.setMode
        }), this.customCheckBox({
            label: 'Evaluate',
            checked: this.env['mode'] === 'evaluate',
            value: 'evaluate',
            action: this.setMode
        }))));
    };
    class_1.prototype.renderSettingsContainer = function () {
        return (h("div", { class: "settings-tab-container" }, this.renderModeConfigContainer(), this.renderRoleConfigContainer()));
    };
    class_1.prototype.renderBottomContent = function () {
        return this.renderTabs([
            {
                name: 'Settings',
                content: this.renderSettingsContainer()
            },
            {
                name: 'Embed',
                content: null
            }
        ]);
    };
    class_1.prototype.renderStudentHeader = function (smallView) {
        var _this = this;
        if (smallView === void 0) { smallView = false; }
        return (h("div", { class: classnames('student-view-header', {
                collapsed: this.collapsed === 'student',
                toggled: this.isToggled()
            }) }, h("div", { class: "topContent" }, this.renderHeaderTitleInfo({
            title: 'Student view',
            description: 'The view a student (or instructor) sees when entering or reviewing the interaction.',
            options: [this.env['mode'], this.currentOption]
        }), h("div", { class: "buttons-container" }, h("div", { class: classnames('toggle-container', 'student', {
                toggled: this.isToggled()
            }), onClick: function () { return _this.toggleStudentSettings(); } }, h("i", { class: "material-icons toggle-icon" }, this.studSettVisible ? 'toggle_on' : 'toggle_off'), h("span", { class: "toggle-text" }, "Options"))), !smallView && (h("i", { class: classnames('material-icons', 'collapse-icon', {
                collapsed: this.collapsed === 'authoring'
            }), onClick: function () { return _this.collapsePanel('authoring'); } }, this.collapsed === 'authoring'
            ? 'format_indent_increase'
            : 'format_indent_decrease')), smallView && (h("div", { class: "mobile-button", onClick: function () { return (_this.mobileTabIndex = 0); } }, h("span", null, "AUTHORING VIEW")))), h("div", { class: "bottomContent" }, this.renderBottomContent())));
    };
    class_1.prototype.renderCollapsedPanel = function (title, toggled) {
        if (toggled === void 0) { toggled = undefined; }
        return (h("div", { class: classnames('collapsed-panel', {
                toggled: toggled
            }) }, h("span", null, title)));
    };
    class_1.prototype.render = function () {
        switch (this.state) {
            case ViewState.LOADING:
                return (h("div", { class: "root loading" }, h("div", { class: "lmask" })));
            case ViewState.ERROR:
                return h("div", { id: "error" }, "Error...");
            case ViewState.READY:
                return (h("div", { class: classnames('root', {
                        multiplePies: this.multiplePies
                    }), ref: this.handleRootEl }, this.renderDocHolder(), this.renderContent()));
        }
    };
    Object.defineProperty(class_1, "watchers", {
        get: function () {
            return {
                "config": ["watchConfig"],
                "modelSchemaJSONURI": ["watchModelSchemaJSONURI"],
                "configureSchemaJSONURI": ["watchConfigureSchemaJSONURI"]
            };
        },
        enumerable: false,
        configurable: true
    });
    return class_1;
}());
PieDemoContent.style = pieDemoCss;
export { PieDemoContent as pie_demo_content };
